var glob = require('glob');
var _ = require('underscore');
var fs = require('fs');
var path = require('path');

var Instrumenter = require('istanbul').Instrumenter;

function CoverageAllSourcesReporter(config) {
  config = config || {};
  var instrumenter = new Instrumenter(config.istanbul);
	this.adapters = [];
	this.onBrowserComplete = function(browser, result) {
		var opts = {cwd: process.cwd()};

		var include = glob.sync(config.include, opts);
		var exclude = config.exclude ? glob.sync(config.exclude, opts) : [];
		var all = _.difference(include, exclude);

		if (!result.coverage) {
			result.coverage = {};
		}
		var cov = result.coverage;

		all.forEach(function(file) {
			file = path.resolve(opts.cwd, file);
			if (!cov[file]) {
				instrumenter.instrumentSync(fs.readFileSync(file, 'utf-8'), file);
				Object.keys(instrumenter.coverState.s).forEach(function (key) {
				    instrumenter.coverState.s[key] = 0;
				});
				cov[file] = instrumenter.coverState;
			}
		});
	};
}

CoverageAllSourcesReporter.$inject = ['config.coverageReporter'];

module.exports = {
	'reporter:coverage-allsources': ['type', CoverageAllSourcesReporter]
}
